//
//  MyDocument.m
//  Created by Francesco Germinara on 11/5/05.
//  Freeware 2005
//  www.germinara.it

//Subclass della classe NSDocument per gestire il caricamento, la visualizzazione e il salvataggio dei dati

#import "MyDocument.h"

@implementation MyDocument

- (id)init
{
    self = [super init];
    if (self) {
  	 theLoadedData=nil;
    }
    return self;
}

- (void) dealloc {
	[super dealloc];
}


- (NSString *)windowNibName
{
    // Override returning the nib file name of the document
    // If you need to use a subclass of NSWindowController or if your document supports multiple NSWindowControllers, you should remove this method and override -makeWindowControllers instead.
    return @"MyDocument";
}

- (void)windowControllerDidLoadNib:(NSWindowController *) aController
{
    [super windowControllerDidLoadNib:aController];
  	
	if(theLoadedData != nil){
      [theHexView setNewData:theLoadedData];
	  [theLoadedData release]; 
     }
	 
     [theHexView setMenu:theHexViewContextMenu];
	 [theHexView setOffSetPositionIndicator:theHexViewOffSetPos];
	
	 [theHexView setAsciiView:theAsciiView];
     [theAsciiView setHexView:theHexView];

}

- (NSData *)dataRepresentationOfType:(NSString *)aType
{
  unsigned char *tmpBuffer;
   int nBytes=0;
  tmpBuffer=[theHexView getBufferData:&nBytes];
  NSData *dataToWrite;
  dataToWrite=[[NSData alloc] initWithBytes:tmpBuffer length:nBytes];
  free(tmpBuffer);
  

    // Insert code here to write your document from the given data.  You can also choose to override -fileWrapperRepresentationOfType: or -writeToFile:ofType: instead.
    
    // For applications targeted for Tiger or later systems, you should use the new Tiger API -dataOfType:error:.  In this case you can also choose to override -writeToURL:ofType:error:, -fileWrapperOfType:error:, or -writeToURL:ofType:forSaveOperation:originalContentsURL:error: instead.

    return dataToWrite;
}

- (BOOL)loadDataRepresentation:(NSData *)data ofType:(NSString *)aType
{
   theLoadedData=[data retain];

    // Insert code here to read your document from the given data.  You can also choose to override -loadFileWrapperRepresentation:ofType: or -readFromFile:ofType: instead.
    
    // For applications targeted for Tiger or later systems, you should use the new Tiger API readFromData:ofType:error:.  In this case you can also choose to override -readFromURL:ofType:error: or -readFromFileWrapper:ofType:error: instead.
    
    return YES;
}

@end
